'use strict';

var _require = require('./constants'),
    scale = _require.scale;

var _require2 = require('./util'),
    idx = _require2.idx,
    px = _require2.px,
    num = _require2.num,
    neg = _require2.neg;

module.exports = function (props) {
  var style = {};
  var sc = idx(['theme', 'space'], props) || scale;

  if (props.m) style.margin = mx(sc)(props.m);
  if (props.mt) style.marginTop = mx(sc)(props.mt);
  if (props.mr) style.marginRight = mx(sc)(props.mr);
  if (props.mb) style.marginBottom = mx(sc)(props.mb);
  if (props.ml) style.marginLeft = mx(sc)(props.ml);

  if (props.mx) {
    style.marginLeft = mx(sc)(props.mx);
    style.marginRight = mx(sc)(props.mx);
  }
  if (props.my) {
    style.marginTop = mx(sc)(props.my);
    style.marginBottom = mx(sc)(props.my);
  }

  if (props.p) style.padding = mx(sc)(props.p);
  if (props.pt) style.paddingTop = mx(sc)(props.pt);
  if (props.pr) style.paddingRight = mx(sc)(props.pr);
  if (props.pb) style.paddingBottom = mx(sc)(props.pb);
  if (props.pl) style.paddingLeft = mx(sc)(props.pl);

  if (props.px) {
    style.paddingLeft = mx(sc)(props.px);
    style.paddingRight = mx(sc)(props.px);
  }
  if (props.py) {
    style.paddingTop = mx(sc)(props.py);
    style.paddingBottom = mx(sc)(props.py);
  }

  return style;
};

var mx = function mx(scale) {
  return function (n) {
    return num(n) ? px((scale[Math.abs(n)] || Math.abs(n)) * (neg(n) ? -1 : 1)) : n;
  };
};